<template>
  <div class="q-py-md">
    <p style="text-align: center">
      <strong>{{ parentDoc.title }}</strong> |
      <a :href="docUrl" target="_blank">{{ lastModified }}</a>
    </p>

    <q-stepper
      alternative-labels
      flat
      v-model="step"
      ref="stepper"
      color="primary"
      animated
    >
      <template v-for="(section, key) in progress">
        <q-step
          class="tooltip"
          :key="key"
          :name="section.title"
          :title="section.label"
          :icon="section.icon"
          :color="section.color"
          ><span class="tooltiptext">{{ section.title }}</span></q-step
        >
      </template>
    </q-stepper>
  </div>
</template>

<script>
import moment from "moment";

export default {
  name: "DocumentProgress",
  props: ["parentDoc", "groupCopy", "latestShowableRevision"],
  data: function () {
    return {
      step: 0,
    };
  },
  computed: {
    latestRevisionId() {
      if (!this.groupCopy || !this.groupCopy.revisions) return null;

      var allRevisions = Object.keys(this.groupCopy.revisions);

      if (
        !this.latestShowableRevision ||
        this.latestShowableRevision === 0 ||
        this.latestShowableRevision === -1
      ) {
        // just return the latest
        return allRevisions[allRevisions.length - 1];
      }

      // find the most recent, before or at the given timestamp limit
      for (let i = 0; i < allRevisions.length; i++) {
        const rev = this.groupCopy.revisions[allRevisions[i]];
        var createdAt = new moment(rev.modifiedAt);

        if (
          createdAt.isAfter(
            new moment.utc(parseInt(this.latestShowableRevision))
          )
        ) {
          // console.log(createdAt.valueOf() + " is greater than " + this.latestShowableRevision);

          // this edit was later than the timestamp limit
          if (i === 0) return null;

          // previous is valid, return that
          return allRevisions[i - 1];
        }
      }

      return allRevisions[allRevisions.length - 1];
    },
    lastModified() {
      if (!this.latestRevisionId) return "Not yet started";
      var latest = this.groupCopy.revisions[this.latestRevisionId];

      return (
        "Last edited " +
        moment
          .duration(new moment(latest.modifiedAt).diff(new moment()))
          .humanize(true)
      );
    },
    docUrl() {
      return `https://docs.google.com/document/d/${this.groupCopy.driveCopyId}/edit#`;
    },
    progress() {
      var sectionsProgress = [];

      if (!this.groupCopy) return sectionsProgress;

      var revisionIds =
        this.groupCopy.revisions !== undefined
          ? Object.keys(this.groupCopy.revisions)
          : [];

      var lastRevision = null;
      var previousRevision = null;

      if (this.latestRevisionId) {
        lastRevision = this.groupCopy.revisions[this.latestRevisionId];
        var index = revisionIds.indexOf(this.latestRevisionId);
        if (index > 0) 
        {
          previousRevision = this.groupCopy.revisions[revisionIds[index - 1]];
        }
      }

        for (var i = 0; i < this.parentDoc.sections.length; i++) 
        {
            var color = "grey-5";
            var icon = "hourglass_empty";

            if (revisionIds.length > 0 && 
                lastRevision && 
                lastRevision.responses &&
                /\S/.test(lastRevision.responses[i]) &&
                (!this.parentDoc.initialState || lastRevision.responses[i] !== this.parentDoc.initialState[i])) 
            {
                // string is not empty, not just whitespace, and is different from the parent doc's content (if available)

                // if there's more than one revision and the response area isn't blank, check to see
                // if the section should be marked as in progress
                if(previousRevision && (!previousRevision.responses ||
                    lastRevision.responses[i] !== previousRevision.responses[i]))
                {
                    // this response has changed since the previous revision
                    color = "orange-5";
                    icon = "create";
                }
                else
                {
                  color = "green-5";
                  icon = "done";
                }
            }

            sectionsProgress.push({
                title: this.parentDoc.sections[i].data.title,
                color: color,
                label: "Section " + (i + 1),
                icon: icon,
            });
        }
        return sectionsProgress;
    },
  },
  mounted() {},
};
</script>

<style>
.tooltip {
  position: relative;
  display: inline-block;
  border-bottom: 1px dotted black;
}

.tooltip .tooltiptext {
  visibility: hidden;
  width: 120px;
  background-color: black;
  color: #fff;
  text-align: center;
  border-radius: 6px;
  padding: 5px 0;

  /* Position the tooltip */
  position: absolute;
  z-index: 1;
  top: 100%;
  left: 50%;
  margin-left: -60px;
}

.tooltip:hover .tooltiptext {
  visibility: visible;
}
</style>